#ifndef _LIB_HOWTO_GAUSS_H_
#define _LIB_HOWTO_GAUSS_H_

/**
 *  Apply discrete convolution to the image with a truncated sampled Gaussian kernel
 *
 */
void gaussconv_sampled_kernel(float* in, float* out, int w, int h, float sigma, int k);


/**
 * Continuous Gaussian convolution of the DFT interpolate.
 *
 */
void gaussconv_dft(float* in, float* out, int w, int h, float sigma);


/**
 * Continuous Gaussian convolution of the DCT interpolate.
 *
 */
void gaussconv_dct(float* in, float* out, int w, int h, float sigma);



/**
 *
 * Lindeberg discrete scale-space smoothing operator.
 */
void gaussconv_lindeberg(float* in, float* out, int w, int h, float sigma, float g);


#endif
